/**
 * RJLogicalArray.java
 * 
 * This java class corresponds to R LogicalArray 
 */
package org.bioconductor.packages.rservices;
import java.util.Arrays;

public class RJLogicalArray extends RJArray {
    protected boolean[] value=new boolean[0];
    
    public RJLogicalArray() { 
    }
    
    public RJLogicalArray(boolean[] value, int[] dim, Object[] dimnames) {
            this.value=value;
	    this.dim=dim;
	    this.dimnames=dimnames;
    }
    
    /**
     * Sets the value for this RJLogicalArray.
     *
     * @param value
     */
    public void setValue (boolean[] value) {
        this.value=value;
    }
    
    /**
     * Gets the value for this RJLogicalArray.
     *
     * @return value
     */
    public boolean[] getValue () {
        return value;
    }  
        
    public boolean equals(Object inputObject) {
	boolean res = getClass().equals(inputObject.getClass());
	if(res) {
	    RJLogicalArray obj=(RJLogicalArray)inputObject;
	    int[] objDim=obj.getDim();
	    boolean[] objValue=obj.getValue();
	    Object[] objDimnames=obj.getDimnames();
	    res=res && Arrays.equals(value, objValue);
	    if((dim==null)||(objDim==null))
		res=res && (dim==objDim);
	    else
	    	res=res && Arrays.equals(objDim, dim);
	    if((dimnames==null)||(objDimnames==null))
		res=res && (dimnames==objDimnames);
	    else
	    	res=res && Arrays.deepEquals(dimnames, objDimnames);
	}
	return res;
    }

    public String toString() {
        StringBuffer res=new StringBuffer("RJLogicalArray {");
        res.append("value= "+Arrays.toString(value));
	if (dim==null)
	    res.append(", dim=null");
	else
            res.append(", dim= "+Arrays.toString(dim));
	if (dimnames==null)
	    res.append(", dimnames=null");
	else
            res.append(", dimnames= "+Arrays.deepToString(dimnames));
        res.append(" }");
        return res.toString();
    }      
}
        
